//include libraries , define constants
#include <math.h>
#define AVSTAND 0.15 // type the distance btw microphones in your setup (here we have 15 centimetres)
#define PAUSE 300

// Microphone pines used for ATM Mega board is 6 and 5
#define micL 6
#define micR 5

// MACROS to computer sound direction
// TIME_TO_RAD
#define time_to_rad(time) asin((time * 0.000001 * 340.00) / (AVSTAND))
// RAD_TO_DEG
#define rad2deg(rad) (int)rad*180.0/M_PI

//time global variable  
float tid1;
float tid3;
float grader;

void setup()
{
  Serial.begin(9600);
  Serial2.begin(9600);
  
  pinMode(micL, INPUT);
  pinMode(micR, INPUT);
}

void loop()
{
  tid1 = 0;
  tid3 = 0;

  // PIN 6
  if (bitRead(PINH, 3)==1) {
    tid1 = micros();

    // PIN 5
    while (bitRead(PINE, 3)==0) {}
    
    tid3 = tid1 - micros();
    
    if (abs(tid3)<1000) {
      grader = rad2deg(1.5*time_to_rad(tid3));
      
      if (!isnan(grader)) {  
        Serial.println((String) grader + "\r\n" + grader);
        Serial2.println((String) grader + "\r\n" + grader);
      }
    }
    delay(PAUSE);
  }

  // PIN 5
  if (bitRead(PINE, 3)==1) {
    tid1 = micros();

    // PIN 6
    while (bitRead(PINH, 3)==0) {}
    
    tid3 = micros() - tid1;

     if (abs(tid3)<1000) {
      grader = rad2deg(2.5*time_to_rad(tid3));
      if (!isnan(grader)) {  
        Serial.println((String) grader + "\r\n" + grader);
        Serial2.println((String) grader + "\r\n" + grader);
      }
    }
    delay(PAUSE);
  }
}
